<template>
  <Card class="address-card" title="آدرس">
    <template #actions>
      <Button type="text" color="dark" round size="sm" light @click.native="$router.push(`/dashboard/addresses/${address.id}`)">
        <template #icon>
          <EditIcon />
        </template>
      </Button>
      <InlineDeleteButton @delete="onDelete" />
    </template>
    <div class="row">
      <p class="key">آدرس:</p>
      <p class="value">{{ getAddress }}</p>
    </div>
    <div class="row">
      <p class="key">کد پستی:</p>
      <p class="value ltr">{{ address.zipcode }}</p>
    </div>
    <div class="row">
      <p class="key">نام و نام خانوادگی تحویل گیرنده:</p>
      <p class="value">{{ address.receiverName }}</p>
    </div>
    <div class="row">
      <p class="key">تلفن همراه تحویل گیرنده:</p>
      <p class="value ltr">{{ address.phone }}</p>
    </div>
  </Card>
</template>

<script>
import Card from "@/components/base/Card";
import Button from "@/components/base/Button";
import InlineDeleteButton from "@/components/base/InlineDeleteButton";
import EditIcon from "@/assets/svgs/edit.svg";

export default {
  name: "AddressesCard",
  components: {
    Card,
    Button,
    EditIcon,
    InlineDeleteButton
  },
  props: {
    address: {
      type: Object,
      required: true
    }
  },
  computed: {
    getAddress() {
      return `${this.address.state}، ${this.address.city}، ${this.address.address}`
    }
  },
  methods: {
    onDelete() {
      const info = {
        id: this.address.id,
        token: this.$store.getters['auth/getToken']
      }
      this.$store.dispatch('addresses/deleteAddress', info).then(response => {
        if (response.status === 200) {
          this.$store.dispatch('notifications/push', {
            message: 'آدرس با موفقیت حذف شد.',
            light: true,
            type: 'success',
            timeout: 2500
          });
          this.$emit('delete', this.address.id);
        }
      }).catch(error => {
        this.$store.dispatch('notifications/push', {
          message: 'خطا در اتصال به سرور. دقایقی دیگر دوباره تلاش کنید.',
          type: 'error',
          timeout: 3500
        });
      })
    }      
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.row
  display flex
  align-items center
  justify-content space-between
  padding $sm $md
  flex-wrap wrap
  @media only screen and (max-width 1100px) 
    padding $sm 0
  @media only screen and (max-width 600px) 
    padding $xsm 0
    flex-direction column
    align-items flex-start
  &:not(:last-of-type)
    border-bottom 1px solid rgba($black, .07)
  &:hover
    background-color rgba(black, .03)

.value
  width 60%
  @media only screen and (max-width 1000px) 
    width 50%
  @media only screen and (max-width 600px) 
    width 100%
    margin-top $xsm
  direction rtl
  opacity .7
  &.ltr
    direction ltr
    text-align right

.key
  min-width max-content
  margin-left $md
  @media only screen and (max-width 600px) 
    margin-left 0
</style>